ML.eb.FrameName = "MLExtraBagFrame";
ML.eb.ScrollName = ML.eb.FrameName .. "ScrollFrame" .. "ScrollBar";
ML.eb.stTypes = {
	["TYPE_4"] = {
		["group"] = 3,
		["index"] = 1,
		["name"]  = "SYS_MONEY_TYPE_4",
		["tips"]  = "SYS_MONEY_TIPS_4",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.125, 0.15625, 0, 1},
	},
	["TYPE_8"] = {
		["group"] = 3,
		["index"] = 2,
		["name"]  = "SYS_MONEY_TYPE_8",
		["tips"]  = "SYS_MONEY_TIPS_8",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.25, 0.28125, 0, 1},
	},
	["TYPE_9"] = {
		["group"] = 2,
		["index"] = 1,
		["name"]  = "SYS_MONEY_TYPE_9",
		["tips"]  = "SYS_MONEY_TIPS_9",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.28125, 0.3125, 0, 1},
	},
	["TYPE_10"] = {
		["group"] = 1,
		["index"] = 3,
		["name"]  = "SYS_MONEY_TYPE_10",
		["tips"]  = "SYS_MONEY_TIPS_10",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.3125,0.34375,  0, 1},
	},
	["TYPE_11"] = {
		["group"] = 1,
		["index"] = 1,
		["name"]  = "SYS_MONEY_TYPE_11",
		["tips"]  = "SYS_MONEY_TIPS_11",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.34375, 0.375, 0, 1},
	},
	["TYPE_12"] = {
		["group"] = 1,
		["index"] = 2,
		["name"]  = "SYS_MONEY_TYPE_12",
		["tips"]  = "SYS_MONEY_TIPS_12",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.375, 0.40625, 0, 1},
	},
	["TYPE_13"] = {
		["group"] = 2,
		["index"] = 2,
		["name"]  = "SYS_MONEY_TYPE_13",
		["tips"]  = "SYS_MONEY_TIPS_13",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.40625, 0.4375, 0, 1},
	},
	["TYPE_14"] = {
		["group"] = 3,
		["index"] = 3,
		["name"]  = "SYS_MONEY_TYPE_14",
		["tips"]  = "SYS_MONEY_TIPS_14",
		["icon"]  = "Interface/MoneyFrame/MoneyIcons",
		["uv"]    = {0.4375, 0.46875, 0, 1},
	},
};
ML.eb.MaxGarbageItems = 49;


function ML.eb.MsgDialog( message, okFunc, cancelBtn )
	if( okFunc == nil )then okFunc = ""; end;
	if( cancelBtn == nil )then cancelBtn = false; end;
	MLExtraDialogText:SetText( message );

	MLExtraDialogOk:SetText( TEXT( "SO_YES" ) );
	MLExtraDialogCancel:SetText( TEXT( "SO_NO" ) );
	
	MLExtraDialogCancel:Hide();
	MLExtraDialogOk:ClearAllAnchors();
	MLExtraDialogOk:SetAnchor( "TOP", "TOP", MLExtraDialog, 0, 48 );
	
	MLExtraDialog.okFunc = okFunc;
	
	if( cancelBtn )then
		MLExtraDialogCancel:Show();
		
		MLExtraDialogOk:ClearAllAnchors();
		MLExtraDialogOk:SetAnchor( "TOP", "TOP", MLExtraDialog, -60, 48 );
		
		MLExtraDialogCancel:ClearAllAnchors();
		MLExtraDialogCancel:SetAnchor( "TOP", "TOP", MLExtraDialog, 60, 48 );
	end;
	
	MLExtraDialog:Show();
end;

function ML.eb.DialogShow( this )
	MLExtraModal:Show();
end;

function ML.eb.DialogHide( this )
	MLExtraModal:Hide();
end;

function ML.eb.DialogOkClick( this )
	MLExtraDialog:Hide();
	local okFunc = this:GetParent().okFunc;
	local func = _G[ okFunc ];
	if( func ~= nil )then func(); end;
end;

function ML.eb.OnLoad( this )
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256 , 256 );
end;

function ML.eb.OnShow( this )
	_G[ ML.eb.FrameName .. "Title" ]:SetText( "Инвентарь [B]" );
	
	for n = 1, 6 do
		_G[ ML.eb.FrameName .. "BagSlotsBag" .. n .. "Title" ]:SetText( n );
		if( n > 1 )then
			_G[ ML.eb.FrameName .. "BagSlotsBag" .. n ]:ClearAllAnchors();
			_G[ ML.eb.FrameName .. "BagSlotsBag" .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ ML.eb.FrameName .. "BagSlotsBag" .. ( n - 1 ) ], 0, 0 );
		end;
		
		if( n >=3 )and( n <= 6 )then
			local isLet, letTime = GetBagPageLetTime( n );
			if ( isLet and letTime == -1 ) then
				_G[ "MLScrollChildBag" .. n .. "Title" ]:SetText( "Сумка " .. n .. "   |cffFF2222Используйте функцию аренды|r" );
			else
				_G[ "MLScrollChildBag" .. n .. "Title" ]:SetText( "Сумка " .. n .. "   " .. MLib.NormalizationTime( letTime ) );
			end;
		else
			_G[ "MLScrollChildBag" .. n .. "Title" ]:SetText( "Сумка " .. n );
		end;
		if( mAutoLootVariables[ "Expand" .. n ] == nil )then mAutoLootVariables[ "Expand" .. n ] = true; end;
		_G[ "MLScrollChildBag" .. n ].Expand = mAutoLootVariables[ "Expand" .. n ];
		for i = 1, 30 do
			local _pre = _G[ "MLScrollChildBag" .. n .. "Item" .. ( i - 1 ) ];
			_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:ClearAllAnchors();
			if( _pre ~= nil )then
				_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:SetAnchor( "TOPLEFT", "TOPRIGHT", _pre, 2, 0 );
			else
				_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:SetAnchor( "TOPLEFT", "TOPLEFT", _G[ "MLScrollChildBag" .. n ], 6, 29 );
			end;
			_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:SetID( ( n - 1 ) * 30 + i );
		end;
		_G[ "MLScrollChildBag" .. n .. "Item11" ]:ClearAllAnchors();
		_G[ "MLScrollChildBag" .. n .. "Item11" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildBag" .. n .. "Item1" ], 0, 2 );
		_G[ "MLScrollChildBag" .. n .. "Item21" ]:ClearAllAnchors();
		_G[ "MLScrollChildBag" .. n .. "Item21" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildBag" .. n .. "Item11" ], 0, 2 );
	end;
	
	if( mAutoLootVariables.Expand7 == nil )then mAutoLootVariables.Expand7 = true; end;
	MLScrollChildGoods.Expand = mAutoLootVariables.Expand7;
	
	for n = 1, 50 do
		local _pre = _G[ "MLScrollChildGoodsItem" .. ( n - 1 ) ];
		_G[ "MLScrollChildGoodsItem" .. n ]:ClearAllAnchors();
		if( _pre ~= nil )then
			_G[ "MLScrollChildGoodsItem" .. n ]:SetAnchor( "TOPLEFT", "TOPRIGHT", _pre, 2, 0 );
		else
			_G[ "MLScrollChildGoodsItem" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", _G[ "MLScrollChildGoods" ], 6, 29 );
		end;
		_G[ "MLScrollChildGoodsItem" .. n ]:SetID( n );
	end;
	_G[ "MLScrollChildGoodsItem11" ]:ClearAllAnchors();
	_G[ "MLScrollChildGoodsItem11" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildGoodsItem1" ], 0, 2 );
	_G[ "MLScrollChildGoodsItem21" ]:ClearAllAnchors();
	_G[ "MLScrollChildGoodsItem21" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildGoodsItem11" ], 0, 2 );
	_G[ "MLScrollChildGoodsItem31" ]:ClearAllAnchors();
	_G[ "MLScrollChildGoodsItem31" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildGoodsItem21" ], 0, 2 );
	_G[ "MLScrollChildGoodsItem41" ]:ClearAllAnchors();
	_G[ "MLScrollChildGoodsItem41" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildGoodsItem31" ], 0, 2 );
	
	for n = 2, 6 do
		_G[ "MLScrollChildBag" .. n ]:ClearAllAnchors();
		_G[ "MLScrollChildBag" .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildBag" .. ( n - 1 ) ], 0, 3 );
	end;
	_G[ "MLScrollChild" .. "Goods" ]:ClearAllAnchors();
	_G[ "MLScrollChild" .. "Goods" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "MLScrollChildBag6" ], 0, 3 );
	_G[ "MLScrollChild" .. "Goods" .. "Title" ]:SetText( "|cffFF0000Внимание!|r сумка магазина" );
	
	ML.eb.OnPaint( _G[ ML.eb.ScrollName ] );
	
	local _scale = GetUIScale();
	_G[ ML.eb.FrameName ]:ClearAllAnchors();
	_G[ ML.eb.FrameName ]:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, mAutoLootVariables.BagFrameX / _scale, mAutoLootVariables.BagFrameY / _scale );
	
	_G[ ML.eb.FrameName .. "BagSlots" .. "Goods" .. "AddIcon" ]:SetTexture( "interface/bagframe/mallicon" );
	_G[ ML.eb.FrameName .. "BagSlots" .. "MagicBox" .. "AddIcon" ]:SetTexture( "interface/bagframe/magicboxtab1" );
	_G[ ML.eb.FrameName .. "BagSlots" .. "Partner" .. "AddIcon" ]:SetTexture( "interface/bagframe/magicboxtab2" );
	_G[ ML.eb.FrameName .. "BagSlots" .. "RecycleBin" .. "AddIcon" ]:SetTexture( "interface/addons/mloot/texture/recyclebin" );
	
	MLScrollChildBag1TitleContinue:Hide();
	MLScrollChildBag2TitleContinue:Hide();
	
	MLScrollChildGoodsTitleContinue:Hide();
	MLScrollChildGoodsTitleSort:Hide();
	_G[ ML.eb.FrameName .. "CleanFindTitle" ]:SetText("x");
	
	ML.eb.ShowCurrency();
	
	ML.eb.ShowNewItems();
end;

function ML.eb.OnUpdate( this, elapsedTime )
	if( this:IsVisible() )then
		local X, Y = unpack( {this:GetPos()} );
		mAutoLootVariables.BagFrameX = X;
		mAutoLootVariables.BagFrameY = Y;
		
		local usedSlots, availableSlots, totalSlots = GetBagCount();
		local _percent = math.floor( usedSlots * 100 / availableSlots );
		_G[ ML.eb.FrameName .. "Used" ]:SetText( MLib.PercentColor( 100 - _percent ) .. usedSlots .. "/" .. availableSlots .. "|r" );
		
		for n = 1, 6 do
			local isLet, letTime = GetBagPageLetTime( n );
			for i = 1, 30 do
				if( letTime ~= nil )and( letTime < 0 ) then
					_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:Disable();
					if( not _G[ "MLScrollChildBag" .. n .. "Item" .. i ].CollapsedHidden )then
						_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "Invalid" ]:Show();
					end;
				else
					_G[ "MLScrollChildBag" .. n .. "Item" .. i ]:Enable();
					_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "Invalid" ]:Hide();
				end;
				
				local index, texture, name, itemCount, locked, quality = GetBagItemInfo( _G[ "MLScrollChildBag" .. n .. "Item" .. i ]:GetID() ); 
				local itemButton = _G[ "MLScrollChildBag" .. n .. "Item" .. i ];

				local qualityTexture = _G[ "MLScrollChildBag" .. n .. "Item" .. i .. "Quality" ];
				if( quality > 0 )then
					if( not itemButton.CollapsedHidden )then
						qualityTexture:Show();
					end;
					qualityTexture:SetColor( GetItemQualityColor( quality ) );
				else
					qualityTexture:Hide();
				end;
				
				if( index < 0 )then
					itemButton:Hide();
				else
					itemButton.index = index;
					if( not itemButton.CollapsedHidden )then
						itemButton:Show();
					end;
					if ( string.len( name ) > 0 ) then
						count = count + 1;
					end		
					
					SetItemButtonTexture( itemButton, texture );
					SetItemButtonCount( itemButton, itemCount );
					if( itemButton.garbageLock )then 
						itemButton:Disable();
						SetItemButtonLuminance( itemButton, true );
					else
						itemButton:Enable();
						SetItemButtonLuminance( itemButton, locked );
					end;
					if( GameTooltip:IsVisible() )and( GameTooltip:IsOwned(itemButton) )then
						GameTooltip:SetBagItem( itemButton.index );
					end;
					--BagFrame_UpdateCooldown( itemButton );
				end;
				
			end;
			
		end;
	end;
end;

function ML.eb.OnScroll( this, delta )
	if (delta > 0) then
		this:SetValue(this:GetValue() - 2);
	elseif (delta < 0) then
		this:SetValue(this:GetValue() + 2);
	end;
end;

function ML.eb.OnValueChanged( this )
	local min, max = this:GetMinMaxValues()
	
	_G[ ML.eb.ScrollName .. "ScrollDownButton" ]:Enable();
	_G[ ML.eb.ScrollName .. "ScrollUpButton" ]:Enable();

	if this:GetValue() == min then
		_G[ ML.eb.ScrollName .. "ScrollUpButton" ]:Disable()
	end
	if this:GetValue() == max then
		_G[ ML.eb.ScrollName .. "ScrollDownButton" ]:Disable()
	end
	ML.eb.OnPaint( _G[ ML.eb.ScrollName ] );
end;

function ML.eb.OnPaint( this )
	--local max = math.ceil( ( _G[ "MLScrollChildBag1" ]:GetHeight() * 6 + _G[ "MLScrollChildGoods" ]:GetHeight() + 18 - MLScrollChild:GetHeight() ) / mAutoLootVariables.ScrollDelta );
	
	local max = 0;
	for n = 1, 6 do
		max = max + _G[ "MLScrollChildBag" .. n ]:GetHeight() + 3;
	end;
	max = max + _G[ "MLScrollChildGoods" ]:GetHeight() - MLScrollChild:GetHeight();
	max = math.ceil( max / mAutoLootVariables.ScrollDelta );
	
	this:SetMinMaxValues( 0, max );
	_G[ "MLScrollChildBag1" ]:ClearAllAnchors();
	_G[ "MLScrollChildBag1" ]:SetAnchor( "TOPLEFT", "TOPLEFT", MLScrollChild, 10, -( this:GetValue() * mAutoLootVariables.ScrollDelta ) );
end;

function ML.eb.FindByName( itemName )
end;



function ML.eb.BagItemOnLoad( this )
	this:RegisterEvent("BAG_ITEM_UPDATE");
	this:RegisterEvent("BAG_UPDATE_COOLDOWN");
	this:RegisterForClicks("LeftButton", "RightButton");
end;

function ML.eb.BagItemOnEvent( this, event )
	if ( event == "BAG_ITEM_UPDATE" ) then
		if ( this:IsVisible() and this.index == arg1 ) then
			BagItemButton_Update(this);
		end
	elseif ( event == "BAG_UPDATE_COOLDOWN" ) then
		if ( this:IsVisible() ) then
			BagFrame_UpdateCooldown(this);
		end
	end
end;

function ML.eb.BagItemOnUpdate( this, elapsedTime )
	local index, file, name, itemCount, locked, quality = GetBagItemInfo(this:GetID());
	this.index = index;
	SetItemButtonTexture( this, file );
	SetItemButtonCount( this, itemCount );
	SetItemButtonLuminance( this, locked );


	-- Quality Texture
	local qualityTexture = getglobal(this:GetName().."Quality");
	if ( quality > 0 ) then
		qualityTexture:Show();
		qualityTexture:SetColor(GetItemQualityColor(quality));
	else
		qualityTexture:Hide();
	end

	BagFrame_UpdateCooldown( this );
end;

function ML.eb.BagItemOnClick( this, button, ignoreShift )
	_G[ this:GetName() .. "New" ]:Hide();
	_G[ this:GetName() .. "Find" ]:Hide();
	if( ML.Flags.GarbageSelection )then
		if( button == "LBUTTON" )then ML.tools.AddGarbage( GetBagItemLink( this.index ) ); end;
		if( button == "RBUTTON" )then ML.tools.DeleteGarbage( GetBagItemLink( this.index ) ); end;
	elseif( ML.Flags.SellListSelection )then
		if( button == "LBUTTON" )then ML.tools.AddSellItem( GetBagItemLink( this.index ) ); end;
		if( button == "RBUTTON" )then ML.tools.DeleteSellItem( GetBagItemLink( this.index ) ); end;
	elseif( ML.Flags.DonateListSelection )then
		if( button == "LBUTTON" )then ML.tools.AddDonateItem( GetBagItemLink( this.index ) ); end;
		if( button == "RBUTTON" )then ML.tools.DeleteDonateItem( GetBagItemLink( this.index ) ); end;
	elseif( ( TradeFrame:IsVisible() )and( button == "RBUTTON" ) )then
		local num = 1;
		for n = 1, 8 do
			local file, name, count = GetTradePlayerItemInfo( n );
			if( name ~= nil )then num = num + 1; end;
		end;
		if( num < 9 )then
			PickupBagItem( this.index );
			ClickTradeItem( num );
		end;
	else
		if ( button == "LBUTTON" ) then
			if( IsShiftKeyDown() ) then

				local itemLink = GetBagItemLink( this.index );
				if( ChatEdit_AddItemLink( itemLink ) )then
					return;
				end

				local index, file, name, itemCount, locked = GetBagItemInfo(this:GetID());
				itemCount = itemCount or 0;
				
				if( locked or itemCount <= 1 )then
					return;
				end

				this.AskNumberFrameCallBack = function( button , Number )
					SplitBagItem( this.index , Number );
				end

				OpenAskNumberFrame( 1, itemCount, this, "BOTTOMRIGHT", "TOPRIGHT" );
				return;
			elseif( IsCtrlKeyDown() ) then

				local itemLink = GetBagItemLink( this.index );
				ItemPreviewFrame_SetItemLink( ItemPreviewFrame, itemLink );

				return;
			end

			PickupBagItem(this.index);
		elseif ( button == "RBUTTON" ) then
			if ( GarbageFrame:IsVisible() ) then
				InsertGarbageItem(this.index);
				return;
			end
			if( MLExtraBagFrameGarbageFrame:IsVisible() )then
				ML.eb.InsertGarbageItem( this.index );
				return;
			end;
			if ( IsShiftKeyDown()) then
			
				local bAdd=PartnerFrame_CanAddToPartner(this.index);
				if (bAdd==true) then
					StaticPopupDialogs["ADDPARTNER_DIALOG"].index=this.index;
					StaticPopup_Show("ADDPARTNER_DIALOG");
					return;
				else
					DrawRuneFrame_Open(this.index);
					return;
				end
				
			end
			
			UseBagItem(this.index);
		end

		AskNumberFrame:Hide();
	end;
end;




function ML.eb.ShowHint( this )
	PlaySoundByPath( "sound/interface/ui_icon_move.mp3" );

	GameTooltip:SetOwner( this, "ANCHOR_TOPLEFT", -5, 0 );
	GameTooltip:SetBagItem( this.index );
end;

function ML.eb.ScrollToBag( id )
	id = id - 1;
	_G[ ML.eb.ScrollName ]:SetValue( math.ceil( ( _G[ "MLScrollChildBag1" ]:GetHeight() * id + 3 * id ) / mAutoLootVariables.ScrollDelta ) );
end;

function ML.eb.ReceiveDragToBag( id )
	for n = 1, 30 do
		local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( ( id - 1 ) * 30 + n );
		if( itemCount == 0 )then
			ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. id .. "Item" .. n ], "LBUTTON", 1 );
		end;
	end;
end;


function ML.eb.RecievedItemToGarbage()
	local index = GetCursorItemInfo();
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == index )then ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. n .. "Item" .. i ], "LBUTTON", 1 ); end;
		end;
	end;
	ML.tools.AddGarbage( GetBagItemLink( index ) );
end;

function ML.eb.RecievedItemToSell()
	local index = GetCursorItemInfo();
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == index )then ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. n .. "Item" .. i ], "LBUTTON", 1 ); end;
		end;
	end;
	ML.tools.AddSellItem( GetBagItemLink( index ) );
end;

function ML.eb.RecievedItemToDonate()
	local index = GetCursorItemInfo();
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == index )then ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. n .. "Item" .. i ], "LBUTTON", 1 ); end;
		end;
	end;
	ML.tools.AddDonateItem( GetBagItemLink( index ) );
end;

function ML.eb.ShowBagButtonHint( this )
	local id = this:GetID();
	MLib.TT.Init( this, ML.Name .. " " .. ML.Version, 300, "ANCHOR_TOPRIGHT", 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( "Быстрый переход ко вкладке № " .. id );
	MLib.TT.Space();
	MLib.TT.Line( "Перетащите любой предмет в инвентаре на эту кнопку для того чтобы мгновенно переместить его в " .. id .. "ю сумку (только если в сумке есть свободное место).", 0, 0.75, 0.95 );
end;




function ML.eb.GoodsItemOnLoad( this )
	this:RegisterEvent("BAG_ITEM_UPDATE");
	this:RegisterEvent("BAG_UPDATE_COOLDOWN");
	this:RegisterForClicks("LeftButton", "RightButton");
end;

function ML.eb.GoodsItemOnEvent( this, event )
	if ( event == "BAG_ITEM_UPDATE" ) then
		if ( this:IsVisible() and this:GetID() == arg1 ) then
			GoodsItemButton_Update(this);
		end
	elseif ( event == "BAG_UPDATE_COOLDOWN" ) then
		if ( this:IsVisible() ) then
			GoodsItemButton_UpdateCooldown(this);
		end
	end
end;

function ML.eb.GoodsItemOnClick( this, key )
	_G[ this:GetName() .. "New" ]:Hide();
	_G[ this:GetName() .. "Find" ]:Hide();
	local id = this:GetID();
	if ( key == "LBUTTON" ) then
		if( IsShiftKeyDown() ) then
			local itemLink = GetBagItemLink( id );
			if( ChatEdit_AddItemLink( itemLink ) )then
				return;
			end

			local icon, name, itemCount, locked = GetGoodsItemInfo( this:GetID() );
			itemCount = itemCount or 0;
			if( locked or itemCount <= 1 )then
				return;
			end

			this.AskNumberFrameCallBack = function( button , Number )
				SplitBagItem( this:GetID() , Number );
			end

			OpenAskNumberFrame( 1, itemCount, this, "BOTTOMRIGHT", "TOPRIGHT" );

			return;

		elseif( IsCtrlKeyDown() ) then
			local itemLink = GetBagItemLink(id);
			ItemPreviewFrame_SetItemLink( ItemPreviewFrame, itemLink );
			return;
		end
		PickupBagItem(id);
	elseif ( key == "RBUTTON" ) then
		
		if ( IsShiftKeyDown()) then
		
			local bAdd=PartnerFrame_CanAddToPartner(id);
			if (bAdd==true) then
				StaticPopupDialogs["ADDPARTNER_DIALOG"].index=id;
				StaticPopup_Show("ADDPARTNER_DIALOG");
				return;
			else
				DrawRuneFrame_Open(id);
				return;
			end
		else
			UseBagItem(id);
		end
	end

	AskNumberFrame:Hide();
end;

function ML.eb.GoodsItemOnUpdate( this, elapsedTime )
	local icon, name, count, locked = GetGoodsItemInfo(this:GetID());
	SetItemButtonTexture(this, icon);
	SetItemButtonCount(this, count);
	SetItemButtonLuminance(this, locked);

	-- Quality Texture
	local qualityTexture = getglobal(this:GetName().."Quality");
	if ( count > 0 ) then
		qualityTexture:Show();
		qualityTexture:SetColor(GetItemQualityColor(8));
	else
		qualityTexture:Hide();
	end

	GoodsItemButton_UpdateCooldown(this);
end;

function ML.eb.GoodsShowHint( this )
	PlaySoundByPath("sound\\interface\\ui_icon_move.mp3");
	GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT", -5, 0);
	GameTooltip:SetBagItem(this:GetID());
end;

function ML.eb.ReceiveDragToGoods()
	for n = 1, 50 do
		local icon, name, count, locked = GetGoodsItemInfo( n );
		if( count == 0 )then
			ML.eb.GoodsItemOnClick( _G[ "MLScrollChildGoodsItem" .. n ], "LBUTTON", 1 );
		end;
	end;
end;


function ML.eb.FindByName( itemName )
	local pattern = ML.tools.ChangeCase( itemName );
	local _flag = false;
	for n = 1, 6 do
		for i = 1, 30 do
			local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( i + ( n - 1 ) * 30 );
			name = ML.tools.ChangeCase( name );
			if( name:find( pattern ) ~= nil )and( pattern ~= "" )then
				_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "Find" ]:Show();
				if( not _flag )then ML.eb.ScrollToBag( n ); end;
				_flag = true;
			else
				_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "Find" ]:Hide();
			end;
		end;
	end;
	for n = 1, 50 do
		local icon, name, count, locked = GetGoodsItemInfo( n );
		name = ML.tools.ChangeCase( name );
		if( name:find( pattern ) ~= nil )and( pattern ~= "" )then
			_G[ "MLScrollChildGoodsItem" .. n .. "Find" ]:Show();
			if( not _flag )then ML.eb.ScrollToBag( 7 ); end;
			_flag = true;
		else
			_G[ "MLScrollChildGoodsItem" .. n .. "Find" ]:Hide();
		end;
	end;
end;

function ML.eb.OnHide( this )
	ML.eb.CurrItems = {};
	for n = 1, 6 do
		ML.eb.CurrItems[ n ] = {};
		for i = 1, 30 do
			local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( i + ( n - 1 ) * 30 );
			ML.eb.CurrItems[ n ][ i ] = {
				["name"] = name,
				["count"] = itemCount,
			};
			_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "New" ]:Hide();
		end;
	end;
	ML.eb.CurrItems[ 7 ] = {};
	for n = 1, 50 do
		local icon, name, count, locked = GetGoodsItemInfo( n );
		ML.eb.CurrItems[ 7 ][ n ] = {
			["name"] = name,
			["count"] = count,
		};
		_G[ "MLScrollChildGoodsItem" .. n .. "New" ]:Hide();
	end;
	
	_G[ ML.eb.FrameName .. "GarbageFrame" ]:Hide();
end;

function ML.eb.ShowNewItems()
	for n = 1, 6 do
		for i = 1, 30 do
			local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( i + ( n - 1 ) * 30 );
			_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "New" ]:Hide();
			if( ( ML.eb.CurrItems[ n ][ i ]["name"] ~= name )or( ML.eb.CurrItems[ n ][ i ]["count"] ~= itemCount ) )and( itemCount ~= 0 )then
				if( mAutoLootVariables.NewOnly )then
					if( ML.eb.CurrItems[ n ][ i ]["name"] ~= name )then
						_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "New" ]:Show();
					end;
				elseif( mAutoLootVariables.NewAddCount )then
					if( ML.eb.CurrItems[ n ][ i ]["count"] < itemCount )then
						_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "New" ]:Show();
					end;
				else
					_G[ "MLScrollChildBag" .. n .. "Item" .. i .. "New" ]:Show();
				end;
			end;
		end;
	end;
	for n = 1, 50 do
		local icon, name, count, locked = GetGoodsItemInfo( n );
		_G[ "MLScrollChildGoodsItem" .. n .. "New" ]:Hide();
		if( ( ML.eb.CurrItems[ 7 ][ n ]["name"] ~= name )or( ML.eb.CurrItems[ 7 ][ n ]["count"] ~= count ) )and( count ~= 0 )then
			if( mAutoLootVariables.NewOnly )then
				if( ML.eb.CurrItems[ 7 ][ n ]["name"] ~= name )then
					_G[ "MLScrollChildGoodsItem" .. n .. "New" ]:Show();
				end;
			elseif( mAutoLootVariables.NewAddCount )then
				if( ML.eb.CurrItems[ 7 ][ n ]["count"] < count )then
					_G[ "MLScrollChildGoodsItem" .. n .. "New" ]:Show();
				end;
			else
				_G[ "MLScrollChildGoodsItem" .. n .. "New" ]:Show();
			end;
		end;
	end;
end;


function ML.eb.OptionsMenu()
	local info = {}
	if( UIDROPDOWNMENU_MENU_LEVEL == 1 )then
		info = {}
		info.text = "Только новые предметы"
		info.checked = mAutoLootVariables.NewOnly
		info.func = function() mAutoLootVariables.NewOnly = not mAutoLootVariables.NewOnly; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Только при увеличении стака"
		info.checked = mAutoLootVariables.NewAddCount
		info.func = function() mAutoLootVariables.NewAddCount = not mAutoLootVariables.NewAddCount; end;
		info.value = 2
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = ""
		info.checked = false
		info.func = function() end;
		info.value = 1000
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Отображаемые валюты"
		info.checked = false
		info.hasArrow = 1
		info.value = 3
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Показывать максимальное значение валюты"
		info.checked = mAutoLootVariables.ShowCurrencyMax
		info.func = function() mAutoLootVariables.ShowCurrencyMax = not mAutoLootVariables.ShowCurrencyMax; end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)
	end;
	if( UIDROPDOWNMENU_MENU_LEVEL == 2 )then
		if( UIDROPDOWNMENU_MENU_VALUE == 3 )then
			for key, value in pairs( ML.eb.stTypes )do
				if( mAutoLootVariables[ value.name ] == nil )then mAutoLootVariables[ value.name ] = false; end;
				info = {}
				info.text = TEXT( value.name )
				info.checked = mAutoLootVariables[ key ]
				info.func = function() mAutoLootVariables[ key ] = not mAutoLootVariables[ key ]; ML.eb.ShowCurrency(); ML.eb.ShowCurrency(); end;
				info.value = key
				UIDropDownMenu_AddButton(info, 2)
			end;
		end;
	end;
end;

function ML.eb.ShowCurrency()
	for n = 1, 8 do
		_G[ ML.eb.FrameName .. "Money" .. n ].MoneyType = "";
	end;
	local moneyFrameID = 1;
	for key, value in pairs( ML.eb.stTypes )do
		if( mAutoLootVariables[ key ] )then
			_G[ ML.eb.FrameName .. "Money" .. moneyFrameID ].MoneyType = key;
			moneyFrameID = moneyFrameID + 1;
		end;
	end;
end;

function ML.eb.MoneyFrameUpdate( this, elapsedTime )
	local Icon = _G[ this:GetName() .. "Icon" ];
	local Count = _G[ this:GetName() .. "Count" ];

	if( this.MoneyType == nil )or( ML.eb.stTypes[ this.MoneyType ] == nil )then
		Icon:SetFile("");
		Count:SetText("");
		return nil;
	end;
	
	local _type = ML.eb.stTypes[ this.MoneyType ];
	
	local score, smax, tips = GetPlayerPointInfo( _type.group, _type.index, _type.tips );
	
	Icon:SetFile( TEXT( _type.icon ) );
	Icon:SetTexCoord( _type.uv[1], _type.uv[2], _type.uv[3], _type.uv[4] );
	
	Count:SetColor( 1, 1, 1 );
	Count:SetText( score );
	if( mAutoLootVariables.ShowCurrencyMax )then Count:SetText( score .. " (" .. MLib.ThSeparator( smax ) .. ")" ); end;
end;

function ML.eb.MoneyFrameHint( this )
	if( this.MoneyType == nil )then return nil; end;
	if( ML.eb.stTypes[ this.MoneyType ] == nil )then return nil; end;
	local _type = ML.eb.stTypes[ this.MoneyType ];
	local score, smax, tips = GetPlayerPointInfo( _type.group, _type.index, _type.tips );

	MLib.TT.Init( this, ML.Name .. " " .. ML.Version, 300, "ANCHOR_TOPLEFT", 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( TEXT( _type.name ) );
	MLib.TT.Space();
	MLib.TT.Line( string.gsub( TEXT( _type.tips ), "<number>", "|cffffff00" .. MLib.ThSeparator( smax ) .. "|r" ), 0, 0.75, 0.95 );
end;

function ML.eb.OpenRecycleBin()
	local GF = _G[ ML.eb.FrameName .. "GarbageFrame" ];
	if( GF:IsVisible() )then GF:Hide(); else GF:Show(); end;
end;


-- /run ML.eb.RBOnLoad( MLExtraBagFrameGarbageFrame );
function ML.eb.RBOnLoad( this )
	for n = 1, 49 do
		local _pre = _G[ this:GetName() .. "Item" .. ( n - 1 ) ];
		_G[ this:GetName() .. "Item" .. n ]:Hide();
		_G[ this:GetName() .. "Item" .. n ]:ClearAllAnchors();
		_G[ this:GetName() .. "Item" .. n ].index = n;
		_G[ this:GetName() .. "Item" .. n ].bagID = n;
		
		if( _pre ~= nil )then
			_G[ this:GetName() .. "Item" .. n ]:SetAnchor( "TOPLEFT", "TOPRIGHT", _pre, 2, 0 );
		else
			_G[ this:GetName() .. "Item" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", _G[ this:GetName() ], 10, 10 );
		end;
	end;
--[[
	1  2  3  4  5  6  7
	8  9  10 11 12 13 14
	15 16 17 18 19 20 21 
	22 23 24 25 26 27 28
	29 30 31 32 33 34 35 
	36 37 38 39 49 41 42
	43 44 45 46 47 48 49
]]
	_G[ this:GetName() .. "Item8" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item8" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item1" ], 0, 2 );
	_G[ this:GetName() .. "Item15" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item15" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item8" ], 0, 2 );
	_G[ this:GetName() .. "Item22" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item22" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item15" ], 0, 2 );
	_G[ this:GetName() .. "Item29" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item29" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item22" ], 0, 2 );
	_G[ this:GetName() .. "Item36" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item36" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item29" ], 0, 2 );
	_G[ this:GetName() .. "Item43" ]:ClearAllAnchors();
	_G[ this:GetName() .. "Item43" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ this:GetName() .. "Item36" ], 0, 2 );
	
	_G[ this:GetName() .. "CloseButton" ]:ClearAllAnchors();
	_G[ this:GetName() .. "CloseButton" ]:SetAnchor( "CENTER", "TOPRIGHT", this, -3, 2 );
	
	this.ItemCount = 0;
end;

function ML.eb.RemoveGarbageItem( this )
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == this.bagID )then
				_G[ "MLScrollChildBag" .. n .. "Item" .. i ].garbageLock = false;
			end;
		end;
	end;
	local GF = _G[ ML.eb.FrameName .. "GarbageFrame" ];
	for n = this.index, GF.ItemCount - 1 do
		local GB = _G[ GF:GetName() .. "Item" .. n ];
		GB.bagID = _G[ GF:GetName() .. "Item" .. ( n + 1 ) ].bagID;
	end;
	_G[ GF:GetName() .. "Item" .. GF.ItemCount ]:Hide();
	GF.ItemCount = GF.ItemCount - 1;
	
	--[[ renew textures ]]
	for n = 1, 6 do
		for i = 1, 30 do
			for j = 1, GF.ItemCount do
				if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == _G[ GF:GetName() .. "Item" .. j ].bagID )then
					local index, texture, name, itemCount, locked, quality = GetBagItemInfo( _G[ "MLScrollChildBag" .. n .. "Item" .. i ]:GetID() ); 
					SetItemButtonTexture( _G[ GF:GetName() .. "Item" .. j ], texture );
					SetItemButtonCount( _G[ GF:GetName() .. "Item" .. j ], itemCount );
					SetItemButtonLuminance( _G[ GF:GetName() .. "Item" .. j ], false );
				end;
			end;
		end;
	end;
end;

function ML.eb.RecieveGarbageItem()
	if( CursorItemType() ~= "bag" )then return nil; end;
	_G[ ML.eb.FrameName .. "GarbageFrame" ]:Show();
	local index = GetCursorItemInfo();
	ML.eb.InsertGarbageItem( index );
end;

function ML.eb.InsertGarbageItem( index )
	local bagIndex, itemIndex = 0, 0;
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].index == index )then
				if( CursorItemType() == "bag" )then ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. n .. "Item" .. i ], "LBUTTON", 1 ); end;
				bagIndex = n;
				itemIndex = i;
			end;
		end;
	end;

	local GF = _G[ ML.eb.FrameName .. "GarbageFrame" ];
	if( GF.ItemCount >= ML.eb.MaxGarbageItems )then return nil;	end;
	
	if( bagIndex == 0 )then
	end;
	
	local index, texture, name, itemCount, locked, quality = GetBagItemInfo( _G[ "MLScrollChildBag" .. bagIndex .. "Item" .. itemIndex ]:GetID() ); 
	GF.ItemCount = GF.ItemCount + 1;

	local IB = _G[ "MLScrollChildBag" .. bagIndex .. "Item" .. itemIndex ];
	local GB = _G[ GF:GetName() .. "Item" .. GF.ItemCount ];

	IB.garbageLock = true;
	SetItemButtonTexture( GB, texture );
	SetItemButtonCount( GB, itemCount );
	SetItemButtonLuminance( GB, false );
	GB.bagID = index;
	GB:Show();
end;

function ML.eb.RBOnHide( this )
	for n = 1, 6 do
		for i = 1, 30 do
			_G[ "MLScrollChildBag" .. n .. "Item" .. i ].garbageLock = false;
		end;
	end;
	local GF = _G[ ML.eb.FrameName .. "GarbageFrame" ];
	GF.ItemCount = 0;
	for n = 1, ML.eb.MaxGarbageItems do
		_G[ GF:GetName() .. "Item" .. n ]:Hide();
	end;
end;

function ML.eb.GarbageConfirm()
	ML.eb.MsgDialog( "Подтвердите удаление предметов из корзины!", "MLebDeleteGarbage", true );
end;

function MLebDeleteGarbage()
	for n = 1, 6 do
		for i = 1, 30 do
			if( _G[ "MLScrollChildBag" .. n .. "Item" .. i ].garbageLock )then
				ML.eb.BagItemOnClick( _G[ "MLScrollChildBag" .. n .. "Item" .. i ], "LBUTTON", 1 );
				DeleteCursorItem();
			end;
		end;
	end;
	MLExtraBagFrameGarbageFrame:Hide();
end;


function ML.eb.RecievedItemToBank()
	local _time = TimeLet_GetLetTime( "BankLet" );
	if( _time < 1 )then return nil; end;
	local numItems = GetBankNumItems();
	for n = 1, numItems do
		local texture, name, count, locked = GetBankItemInfo( n );
		if( count == nil )then
			OpenBank();
			PickupBankItem( n );
			return nil;
		end;
	end;
end;

function ML.eb.ShowBankButtonHint( this )
	local _time = TimeLet_GetLetTime( "BankLet" );
	local str = "";
	if( _time >= 0 )then
		local day = math.floor( _time / 60 / 24 );
		local hour = math.floor( ( _time - ( day * 60 * 24 ) ) / 60 );
		local minute = _time - ( day * 60 * 24 ) - ( hour * 60 );
		str = string.format( BANK_LETTIME_MSG, day, hour, minute );
	else
		str = TIMEFLAG_OVERDUE;
	end
	GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT", 4, 0);
	GameTooltip:SetText( ML.Name );
	GameTooltip:AddLine( "|cffFFFFFFБанк|r" );
	GameTooltip:AddSeparator();
	GameTooltip:AddLine( "|cff00B1E1Справа от окна инвентаря будет открыто окно банка.|r" );
	GameTooltip:AddLine( "Перетащите на эту кнопку любой предмет из инвентаря, чтобы переместить его в банк" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "Эта функция доступна только при продленной подписке на мобильный банк" );
	GameTooltip:AddLine( "Время вашей подписки: " .. str );
end;


function ML.eb.BagOnUpdate( this, elapsedTime )
	local max = 150;
	local min = 27;
	
	if( this:GetID() == 7 )then max = 227; end;
	
	local texture = _G[ this:GetName() .. "TitleExpand" ]:GetNormalTexture();
	
	--MLScrollChildBag
	if( this.Expand )and( this:GetHeight() < max )then
		this:SetHeight( max );
		for n = 1, 30 do 
			_G[ this:GetName() .. "Item" .. n ]:Show();
			_G[ this:GetName() .. "Item" .. n ].CollapsedHidden = false;
		end;
		texture:SetTexture( "interface/addons/mloot/texture/arrow-expanded" );
		ML.eb.OnPaint( _G[ ML.eb.ScrollName ] );
		mAutoLootVariables[ "Expand" .. this:GetID() ] = true;
	end;
	
	if( not this.Expand )and( this:GetHeight() > min )then
		for n = 1, 30 do 
			_G[ this:GetName() .. "Item" .. n ]:Hide();
			_G[ this:GetName() .. "Item" .. n ].CollapsedHidden = true;
		end;
		this:SetHeight( min );
		texture:SetTexture( "interface/addons/mloot/texture/arrow-collapsed" );
		ML.eb.OnPaint( _G[ ML.eb.ScrollName ] );
		mAutoLootVariables[ "Expand" .. this:GetID() ] = false;
	end;
end;

--[[ /run dofile("interface/addons/mloot/code/extrabag.lua"); ]]