--[[ ML.hooks ]]

--[[
function BagItemButton_OnClick(this, button, ignoreShift)
	if ( button == "LBUTTON" ) then
		if( IsShiftKeyDown() ) then

			local itemLink = GetBagItemLink( this.index );
			if( ChatEdit_AddItemLink( itemLink ) )then
				return;
			end

			local index, file, name, itemCount, locked = GetBagItemInfo(this:GetID());
			itemCount = itemCount or 0;
			
			if( locked or itemCount <= 1 )then
				return;
			end

			this.AskNumberFrameCallBack = function( button , Number )
				SplitBagItem( this.index , Number );
			end

			OpenAskNumberFrame( 1, itemCount, this, "BOTTOMRIGHT", "TOPRIGHT" );
			return;
		elseif( IsCtrlKeyDown() ) then

			local itemLink = GetBagItemLink( this.index );
			ItemPreviewFrame_SetItemLink( ItemPreviewFrame, itemLink );

			return;
		end

		PickupBagItem(this.index);
	elseif ( button == "RBUTTON" ) then
		if ( GarbageFrame:IsVisible() ) then
			InsertGarbageItem(this.index);
			return;
		end
		if ( IsShiftKeyDown()) then
		
			local bAdd=PartnerFrame_CanAddToPartner(this.index);
			if (bAdd==true) then
				StaticPopupDialogs["ADDPARTNER_DIALOG"].index=this.index;
				StaticPopup_Show("ADDPARTNER_DIALOG");
				return;
			else
				DrawRuneFrame_Open(this.index);
				return;
			end
			
		end
		
		UseBagItem(this.index);
	end

	AskNumberFrame:Hide();
end
]]
local oldBagItemButton_OnClick = BagItemButton_OnClick;
function BagItemButton_OnClick( this, key, ignoreShift )
	if( ML.Flags.GarbageSelection )then
		if( key == "LBUTTON" )then ML.tools.AddGarbage( GetBagItemLink( this.index ) ); end;
		if( key == "RBUTTON" )then ML.tools.DeleteGarbage( GetBagItemLink( this.index ) ); end;
	elseif( ML.Flags.SellListSelection )then
		if( key == "LBUTTON" )then ML.tools.AddSellItem( GetBagItemLink( this.index ) ); end;
		if( key == "RBUTTON" )then ML.tools.DeleteSellItem( GetBagItemLink( this.index ) ); end;
	elseif( ML.Flags.DonateListSelection )then
		if( key == "LBUTTON" )then ML.tools.AddDonateItem( GetBagItemLink( this.index ) ); end;
		if( key == "RBUTTON" )then ML.tools.DeleteDonateItem( GetBagItemLink( this.index ) ); end;
	elseif( ( TradeFrame:IsVisible() )and( key == "RBUTTON" ) )then
		local num = 1;
		for n = 1, 8 do
			local file, name, count = GetTradePlayerItemInfo( n );
			if( name ~= nil )then num = num + 1; end;
		end;
		if( num < 9 )then
			PickupBagItem( this.index );
			ClickTradeItem( num );
		end;
	else
		if( _G[ "MLBagItemButton" .. this:GetName():sub( 14 ) .. "Selection" ] ~= nil )then
			_G[ "MLBagItemButton" .. this:GetName():sub( 14 ) .. "Selection" ]:Hide();
		end;
		oldBagItemButton_OnClick( this, key, ignoreShift );
	end;
end;

GameTooltip_obj = _G.GameTooltip;
local SetBagItem_orig = GameTooltip_obj.SetBagItem;
function GameTooltip:SetBagItem(id)
--	MLGameTooltipImage:Hide();
	SetBagItem_orig( GameTooltip_obj, id );

--[[
	local text1 = _G[ this:GetName() .. "TextLeft1" ];
	local text2 = _G[ this:GetName() .. "TextLeft2" ];

	this:SetWidth( this:GetWidth() + 41 );
	this:SetHeight( this:GetHeight() + 21 );

	MLGameTooltipImage:SetParent( this );
	MLGameTooltipImage:ClearAllAnchors();
	MLGameTooltipImage:SetAnchor( "TOPLEFT", "TOPLEFT", this, 10, 10 );
	MLGameTooltipImage:Show();
	
	text1:ClearAllAnchors();
	text1:SetAnchor( "TOPLEFT", "TOPRIGHT", MLGameTooltipImage, 5, 0 );

	text2:ClearAllAnchors();
	text2:SetAnchor( "TOPLEFT", "BOTTOMLEFT", MLGameTooltipImage, 0, 4 );

	for i = 1, 60 do
		textR = getglobal(this:GetName() .. "TextRight" .. i);
		textR:ClearAllAnchors();
		
		textR:SetAnchor("TOPLEFT", "TOPRIGHT", "$parentTextLeft"..i, 81, 0);
	end;
]]	
	local itemID = ML.tools.itemID( GetBagItemLink( id ) );
	GameTooltip_obj:AddSeparator();
	if( mAutoLootVariables.SellList[ itemID ] )then
		GameTooltip_obj:AddLine( "|cff00FF00Предмет в листе продаж|r" );
	end;
	if( mAutoLootVariables.GarbageList[ itemID ] )then
		GameTooltip_obj:AddLine( "|cffFF0000Предмет в дроп листе|r" ); 
	end;
	if( mAutoLootVariables.DonateList[ itemID ] )then
		GameTooltip_obj:AddLine( "|cffFFAA00Предмет в листе взносов в гильдию|r" ); 
	end;
	GameTooltip_obj:AddLine( "ID: " .. tostring( itemID ) );
	if( mAutoLootVariables.Items[ itemID ] ~= nil )then
		GameTooltip_obj:AddLine( "Max stack: " .. mAutoLootVariables.Items[ itemID ][ 3 ] );
	end;
	--ML.ui.ShowTooltipByLink(self, GetBagItemLink(id));
end

local GroupLootFrame_OnShow_orig = GroupLootFrame_OnShow;
function GroupLootFrame_OnShow( this )
	GroupLootFrame_OnShow_orig( this );
	
	local frame = _G[ "ML_" .. this:GetName() .. "_Selection" ];
	frame:Hide();

	local name, file, count, quality = GetLootRollItemInfo( this.lootIndex );
	
	--[[ Устанавливаем таймер ожидания ]]
	this.timer = mAutoLootVariables.GroupLootDelay;

	--[[ Поехали по спискам ]]
	--[[ Если предмет в списке, то ставим флажок выбора ]]
	local lootType = "none";
	if( ML.tools.IsItemInGreedList( name ) )then lootType = "Greed"; end;
	if( ML.tools.IsItemInRollList( name ) )then lootType = "Roll"; end;
	if( ML.tools.IsItemInPassList( name ) )then lootType = "Cancel"; end;
	this.lootType = lootType;
end;

local GroupLootFrame_OnUpdate_orig = GroupLootFrame_OnUpdate;
function GroupLootFrame_OnUpdate(this, elapsedTime)
	GroupLootFrame_OnUpdate_orig(this, elapsedTime);

	local name, file, count, quality = GetLootRollItemInfo( this.lootIndex );

	--[[ Дальше только если предмета нет в списках ]]
	--[[ Если отключена функция автовыбора и не предустановлен выбор, выходим ]]
	if( mAutoLootVariables.GroupLoot < 1 )and( this.lootType == "none" )then return nil; end;

	--[[ При рарности предмета больше установленной и если не предустановлен выбор выходим ]]
	if( quality > mAutoLootVariables.GroupLootQuality )and( this.lootType == "none" )then return nil; end;
	
	--[[ Отмечаем кнопку выбора ]]
	--[[ Жадность ]]
	local looting = this.lootType;
	local GroupLootType = mAutoLootVariables.GroupLoot;
	if( looting == "none" )then
		if( mAutoLootVariables.GroupLoot == 1 )then looting = "Greed"; end;
		if( mAutoLootVariables.GroupLoot == 2 )then looting = "Roll"; end;
		if( mAutoLootVariables.GroupLoot == 3 )then looting = "Cancel"; end;
	end;
	if( looting == "Greed" )then GroupLootType = 1; end;
	if( looting == "Roll" )then GroupLootType = 2; end;
	if( looting == "Cancel" )then GroupLootType = 3; end;
	local frame = _G[ "ML_" .. this:GetName() .. "_Selection" ];
	frame:ClearAllAnchors();
	frame:SetAnchor("CENTER","CENTER", getglobal(this:GetName()..looting.."Button"), 0, 0);
	frame:Show();

	--[[ Ждем пока пройдет указанное время ]]
	this.timer = this.timer - elapsedTime;
	if( this.timer > 0 )then return nil; end;

	--[[ Кончилось ожидание, действия ]]
	RollOnLoot(this.lootIndex, ML.GL[ GroupLootType ]);
end;

local RollOnLoot_orig = RollOnLoot;
function RollOnLoot( lootIndex, rollType )
	local name, file, count, quality = GetLootRollItemInfo( lootIndex );
	if( IsCtrlKeyDown() )then
		--[[ При нажатом Ctrl добавляем предмет в соответствующий список ]]
		if( rollType == "pass" )then 
			if( not ML.tools.IsItemInPassList( name ) )then
				mAutoLootVariables.PassList[ #mAutoLootVariables.PassList + 1 ] = name;
				ML.Message( '"' .. name .. '"' .. " добавлен с список автоотказа" );
			end;
		end;
		if( rollType == "greed" )then
			if( not ML.tools.IsItemInGreedList( name ) )then
				mAutoLootVariables.GreedList[ #mAutoLootVariables.GreedList + 1 ] = name;
				ML.Message( '"' .. name .. '"' .. " добавлен с список автожадности" );
			end;
		end;
		if( rollType == "roll" )then
			if( not ML.tools.IsItemInRollList( name ) )then
				mAutoLootVariables.RollList[ #mAutoLootVariables.RollList + 1 ] = name;
				ML.Message( '"' .. name .. '"' .. " добавлен с список автотребования" );
			end;
		end;
	end;
	--[[ И юзаем стандартную функцию ]]
	RollOnLoot_orig( lootIndex, rollType );
end;

local Hyperlink_Assign_orig = Hyperlink_Assign;
function Hyperlink_Assign(link, key)
	Hyperlink_Assign_orig( link, key );

	local _type, _data, _name = ParseHyperlink( link );
	local itemID = ML.tools.itemID( link );
	if (_type=="item" and key == "RBUTTON" ) then

		local info = {};
		info.notCheckable = 1;
		info.text = " ";
		info.func = function() end;
		UIDropDownMenu_AddButton( info, 1 );

		if( mAutoLootVariables.SellList[ itemID ] )then
			local info = {};
			info.notCheckable = 1;
			info.text = "Удалить из |cff009900листа продаж|r";
			info.func = function() ML.tools.DeleteSellItem( link ); end;
			UIDropDownMenu_AddButton( info, 1 );
		else
			local info = {};
			info.notCheckable = 1;
			info.text = "Добавить в |cff009900лист продаж|r";
			info.func = function() ML.tools.AddSellItem( link ); end;
			UIDropDownMenu_AddButton( info, 1 );
		end;

		if( mAutoLootVariables.GarbageList[ itemID ] )then
			local info = {};
			info.notCheckable = 1;
			info.text = "Удалить из |cff990000дроп листа|r";
			info.func = function() ML.tools.DeleteGarbage( link ); end;
			UIDropDownMenu_AddButton( info, 1 );
		else
			local info = {};
			info.notCheckable = 1;
			info.text = "Добавить в |cff990000дроп лист|r";
			info.func = function() ML.tools.AddGarbage( link ); end;
			UIDropDownMenu_AddButton( info, 1 );
		end;
		
		if( mAutoLootVariables.ExtraBag )then
			local info = {};
			info.notCheckable = 1;
			info.text = "Найти в инвентаре";
			info.func = function()
							local itemName = ML.tools.itemName( link );
							if( _G[ ML.eb.FrameName ]:IsVisible() )then BagFrame_OnShow( BagFrame ); end;
							BagFrame_OnShow( BagFrame );
							_G[ ML.eb.FrameName .. "Find" ]:SetText( itemName );
							ML.eb.FindByName( itemName );
						end;
			UIDropDownMenu_AddButton( info, 1 );
		end;

		UIDropDownMenu_Refresh( ChatFrameDropDown );
	end;
end;

local org_Logout = Logout;
function Logout()
	GameTooltip_obj.SetBagItem = SetBagItem_orig;
	BagItemButton_OnClick = oldBagItemButton_OnClick;
	return org_Logout();
end;

local BagFrame_OnShow_orig = BagFrame_OnShow;
function BagFrame_OnShow( this )
	BagFrame_OnShow_orig( this );
	GoodsFrame_OnShow( GoodsFrame );
	BankFrame_OnLoad( BankFrame );
	BankFrame:ResetFrameOrder();
	
	local _ExtraFrame = _G[ ML.eb.FrameName ];
	
	if( mAutoLootVariables.ExtraBag )then
		HideUIPanel( this );
		HideUIPanel( GoodsFrame );
		if( _ExtraFrame:IsVisible() )then
			HideUIPanel( _ExtraFrame );
		else
			ShowUIPanel( _ExtraFrame );
		end;
	end;
end;

-- /run dofile("Interface/AddOns/mLoot/code/hooks.lua");