--[[ ML.ui ]]

function ML.ui.StartMessage()
	ML.Message( ML.Name .. ' загружен. Наберите в чат /ml или /loot или нажмите левой кнопкой мыши на кнопку у миникарты, чтобы открыть окно настроек.' );

	ML.Message( "Подбор предметов раритета " .. ML.Qualities[ mAutoLootVariables.Quality ] .. ML.cc .. " и ниже" );
	
	if( mAutoLootVariables.AutoLootElit )then
		ML.Message( "Автолут с элитных мобов " .. ML.consts["Enable"] );
	else
		ML.Message( "Автолут с элитных мобов " .. ML.consts["Disable"] );
	end;

	if( mAutoLootVariables.AutoLootBoss )then
		ML.Message( "Автолут с боссов " .. ML.consts["Enable"] );
	else
		ML.Message( "Автолут с боссов " .. ML.consts["Disable"] );
	end;
	
	ML.Message( "Распределение трофеев в пати " .. ML.RollType[ mAutoLootVariables.RollType ] );
	ML.Message( "Уровень сложности подземелий " .. ML.InstanceLevel[ mAutoLootVariables.InstanceLevel ] );

	if( mAutoLootVariables.AutoSell )then
		ML.Message( "Автопродажа предметов " .. ML.consts["Enable"] );
	else
		ML.Message( "Автопродажа предметов " .. ML.consts["Disable"] );
	end;

	if( mAutoLootVariables.AutoGuildDonate )then
		ML.Message( "Автовзнос в гильдию " .. ML.consts["Enable"] );
	else
		ML.Message( "Автовзнос в гильдию " .. ML.consts["Disable"] );
	end;
	ML.Message( "Лут группы: " .. ML.GroupLoot[ mAutoLootVariables.GroupLoot ] );
	ML.Message( "Лут группы до: " .. ML.Qualities[ mAutoLootVariables.GroupLootQuality ] );
end;

function ML.ui.NormalizeTextures()
	local normalTexture = mLoot_Garbage_Button:GetNormalTexture();
	local sellTexture = mLoot_Sell_Button:GetNormalTexture();
	local donateTexture = mLoot_Guild_Button:GetNormalTexture();
	local normalTexture1 = mLoot_Garbage_Button1:GetNormalTexture();
	local sellTexture1 = mLoot_Sell_Button1:GetNormalTexture();
	local donateTexture1 = mLoot_Guild_Button1:GetNormalTexture();
	
	normalTexture:SetTexture("interface/bagframe/garbagecan-normal");
	normalTexture1:SetTexture("interface/bagframe/garbagecan-normal");
	sellTexture:SetTexture("interface/addons/mloot/texture/sell-normal.png");
	sellTexture1:SetTexture("interface/addons/mloot/texture/sell-normal.png");
	donateTexture:SetTexture("interface/addons/mloot/texture/guild-normal");
	donateTexture1:SetTexture("interface/addons/mloot/texture/guild-normal");
end;

function ML.ui.ActivateGarbageSelection()
	local normalTexture = mLoot_Garbage_Button:GetNormalTexture();
	local sellTexture = mLoot_Sell_Button:GetNormalTexture();
	local normalTexture1 = mLoot_Garbage_Button1:GetNormalTexture();
	local sellTexture1 = mLoot_Sell_Button1:GetNormalTexture();
	if( not ML.Flags.GarbageSelection )then
		--[[ Отключаем режим продажи если включен ]]
		ML.ui.NormalizeTextures();
		ML.Flags.SellListSelection = false;
		ML.Flags.DonateListSelection = false;
		--[[ Отключаем режим продажи если включен ]]
		ML.Flags.GarbageSelection = true;
		normalTexture:SetTexture(mLoot_Garbage_Texture_PlaceHolder:GetDisabledTexture());
		normalTexture1:SetTexture(mLoot_Garbage_Texture_PlaceHolder:GetDisabledTexture());
		ML.Message( "|cffFF0000ВНИМАНИЕ!|r" .. ML.cc .. " Активирован режим |cff990000пометки мусора|r" .. ML.cc .. "." );
		if( mAutoLootVariables.Manual )then
			ML.Message( "Клик левой кнопкой мыши на любой предмет в инвентаре добавит его в дроп лист." );
			ML.Message( "Клик правой кнопкой мыши на любой предмет в инвентаре удалит его из дроп листа." );
			ML.Message( "Для отмены режима пометки мусора снова кликните на кнопку аддона вверху окна инвентаря." );
		end;
	else
		ML.Message( "Деактивирован режим |cff990000пометки мусора|r" .. ML.cc .. "." );
		ML.Flags.GarbageSelection = false;
		ML.ui.NormalizeTextures();
	end;
end;

function ML.ui.ActivateSellListSelection()
	local normalTexture = mLoot_Garbage_Button:GetNormalTexture();
	local sellTexture = mLoot_Sell_Button:GetNormalTexture();
	local normalTexture1 = mLoot_Garbage_Button1:GetNormalTexture();
	local sellTexture1 = mLoot_Sell_Button1:GetNormalTexture();
	if( not ML.Flags.SellListSelection )then
		--[[ Отключаем режим дропа если включен ]]
		ML.ui.NormalizeTextures();
		ML.Flags.GarbageSelection = false;
		ML.Flags.DonateListSelection = false;
		--[[ Отключаем режим дропа если включен ]]
		ML.Flags.SellListSelection = true;
		sellTexture:SetTexture(mLoot_Sell_Texture_PlaceHolder:GetDisabledTexture());
		sellTexture1:SetTexture(mLoot_Sell_Texture_PlaceHolder:GetDisabledTexture());
		ML.Message( "|cffFF0000ВНИМАНИЕ!|r" .. ML.cc .. " Активирован режим |cff009900пометки продаваемых предметов|r" .. ML.cc .. "." );
		if( mAutoLootVariables.Manual )then
			ML.Message( "Клик левой кнопкой мыши на любой предмет в инвентаре добавит его в лист для продажи и при открытии диалога с любым торговцем предмет будет автоматически продан." );
			ML.Message( "Для отмены режима пометки продаваемых предметов снова кликните на кнопку аддона вверху окна инвентаря." );
		end;
	else
		ML.Message( "Деактивирован режим |cff009900пометки продаваемых предметов|r" .. ML.cc .. "." );
		ML.Flags.SellListSelection = false;
		ML.ui.NormalizeTextures();
	end;
end;

function ML.ui.ActivateDonateListSelection()
	local donateTexture = mLoot_Guild_Button:GetNormalTexture();
	local donateTexture1 = mLoot_Guild_Button1:GetNormalTexture();
	if( not ML.Flags.DonateListSelection )then
		--[[ Отключаем режим продажи если включен ]]
		ML.ui.NormalizeTextures();
		ML.Flags.SellListSelection = false;
		ML.Flags.GarbageSelection = false;
		--[[ Отключаем режим продажи если включен ]]
		ML.Flags.DonateListSelection = true;
		donateTexture:SetTexture("interface/addons/mloot/texture/guild-active");
		donateTexture1:SetTexture("interface/addons/mloot/texture/guild-active");
		ML.Message( "|cffFF0000ВНИМАНИЕ!|r" .. ML.cc .. " Активирован режим |cffFFAA00пометки взносов в гильдию|r" .. ML.cc .. "." );
		if( mAutoLootVariables.Manual )then
			ML.Message( "Клик левой кнопкой мыши на любой предмет в инвентаре добавит его в список взносов." );
			ML.Message( "Клик правой кнопкой мыши на любой предмет в инвентаре удалит его из списка взносов." );
			ML.Message( "Для отмены режима пометки взносов в гильдию снова кликните на кнопку аддона вверху окна инвентаря." );
		end;
	else
		ML.Message( "Деактивирован режим |cffFFAA00пометки взносов в гильдию|r" .. ML.cc .. "." );
		ML.Flags.DonateListSelection = false;
		ML.ui.NormalizeTextures();
	end;
end;

function ML.ui.OptionsMenu(this)
	local info = {}
	if UIDROPDOWNMENU_MENU_LEVEL == 1 then
		info = {}
		info.text = "Включен"
		info.checked = mAutoLootVariables.Enabled
		info.func = function() mAutoLootVariables.Enabled = not mAutoLootVariables.Enabled; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Автолут с элитных мобов"
		info.checked = mAutoLootVariables.AutoLootElit
		info.func = function() mAutoLootVariables.AutoLootElit = not mAutoLootVariables.AutoLootElit; end;
		info.value = 2
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Автолут с боссов"
		info.checked = mAutoLootVariables.AutoLootBoss
		info.func = function() mAutoLootVariables.AutoLootBoss = not mAutoLootVariables.AutoLootBoss; end;
		info.value = 3
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Подбор предметов"
		info.checked = false
		info.hasArrow = 1
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Автопродажа предметов"
		info.checked = mAutoLootVariables.AutoSell
		info.func = function() mAutoLootVariables.AutoSell = not mAutoLootVariables.AutoSell; end;
		info.value = 7
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Автовзнос в гильдию"
		info.checked = mAutoLootVariables.AutoGuildDonate
		info.func = function() mAutoLootVariables.AutoGuildDonate = not mAutoLootVariables.AutoGuildDonate; end;
		info.value = 7
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = " "
		info.checked = false
		info.func = function() end;
		info.value = 55
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Сложность подземелий"
		info.checked = false
		info.hasArrow = 1
		info.value = 6
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Распределение трофеев"
		info.checked = false
		info.hasArrow = 1
		info.value = 5
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Лут группы"
		info.checked = false
		info.hasArrow = 1
		info.value = 8
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = "Лут группы до"
		info.checked = false
		info.hasArrow = 1
		info.value = 9
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = " "
		info.checked = false
		info.func = function() end;
		info.value = 50
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Очистить дроп лист"
		info.checked = false
		info.func = function() ML.ui.Dialog("Предупреждение", "Вы действительно хотите очистить дроп лист?", "", "MLClearDropList"); end;
		info.value = 51
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Очистить лист продаж"
		info.checked = false
		info.func = function() ML.ui.Dialog("Предупреждение", "Вы действительно хотите очистить лист продаж?", "", "MLClearSellList"); end;
		info.value = 52
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Очистить лист дроп масок"
		info.checked = false
		info.func = function() ML.ui.Dialog("Предупреждение", "Вы действительно хотите очистить лист масок выбрасываемых предметов?", "", "MLClearDropMasksList"); end;
		info.value = 53
		UIDropDownMenu_AddButton(info, 1)
	end;
	if UIDROPDOWNMENU_MENU_LEVEL == 2 then
		if( UIDROPDOWNMENU_MENU_VALUE == 4 )then
			for n = 0, 5 do
				info = {}
				info.text = ML.Qualities[ n ]
				info.checked = mAutoLootVariables.Quality == n
				info.func = function() mAutoLootVariables.Quality = n; ToggleDropDownMenu(MLOptionMenu); end;
				info.value = n + 1
				UIDropDownMenu_AddButton(info, 2)
			end;
		end;

		if( UIDROPDOWNMENU_MENU_VALUE == 5 )then
			for n = 0, 5 do
				info = {}
				info.text = ML.RollType[ n ]
				info.checked = mAutoLootVariables.RollType == n
				info.func = function() mAutoLootVariables.RollType = n; ML.utils.SetLootMethod(); ToggleDropDownMenu(MLOptionMenu); end;
				info.value = n + 1
				UIDropDownMenu_AddButton(info, 2)
			end;
			info = {}
			info.text = " "
			info.checked = false
			info.func = function() end;
			info.value = 7
			UIDropDownMenu_AddButton(info, 2)

			info = {}
			info.text = ML.RollType[ 100 ]
			info.checked = mAutoLootVariables.RollType == 100
			info.func = function() mAutoLootVariables.RollType = 100; ML.utils.SetLootMethod(); ToggleDropDownMenu(MLOptionMenu); end;
			info.value = 8
			UIDropDownMenu_AddButton(info, 2)

			info = {}
			info.text = ML.RollType[ 101 ]
			info.checked = mAutoLootVariables.RollType == 101
			info.func = function() mAutoLootVariables.RollType = 101; ML.utils.SetLootMethod(); ToggleDropDownMenu(MLOptionMenu); end;
			info.value = 9
			UIDropDownMenu_AddButton(info, 2)
		end;
		if( UIDROPDOWNMENU_MENU_VALUE == 6 )then
			for n = 0, 2 do
				info = {}
				info.text = ML.InstanceLevel[ n ]
				info.checked = mAutoLootVariables.InstanceLevel == n
				info.func = function() mAutoLootVariables.InstanceLevel = n; SetInstanceLevel( ML.IL[ mAutoLootVariables.InstanceLevel ] ); ToggleDropDownMenu(MLOptionMenu); end;
				info.value = n + 1
				UIDropDownMenu_AddButton(info, 2)
			end;
		end;
		if( UIDROPDOWNMENU_MENU_VALUE == 8 )then
			for n = 0, 3 do
				info = {}
				info.text = ML.GroupLoot[ n ]
				info.checked = mAutoLootVariables.GroupLoot == n
				info.func = function() mAutoLootVariables.GroupLoot = n; ToggleDropDownMenu(MLOptionMenu); end;
				info.value = n + 1
				UIDropDownMenu_AddButton(info, 2)
			end;
		end;
		if( UIDROPDOWNMENU_MENU_VALUE == 9 )then
			for n = 0, 5 do
				info = {}
				info.text = ML.Qualities[ n ]
				info.checked = mAutoLootVariables.GroupLootQuality == n
				info.func = function() mAutoLootVariables.GroupLootQuality = n; ToggleDropDownMenu(MLOptionMenu); end;
				info.value = n + 1
				UIDropDownMenu_AddButton(info, 2)
			end;
		end;
	end;
end;

function ML.ui.Dialog(title, message, itemID, OnOkCloseFunction)
	MLDialogFrame_OkOnClose:SetText( "" );
	MLDialogFrame_itemID:SetText( "" );
	if( OnOkCloseFunction ~= nil )then MLDialogFrame_OkOnClose:SetText( OnOkCloseFunction ); end;
	if( itemID ~= nil )then MLDialogFrame_itemID:SetText( itemID ); end;
	MLDialogFrame_Title:SetText( ML.Name .. " " .. ML.Version .. ": " .. title );
	MLDialogFrame_Message:SetText( message );
	MLDialogFrame:Show();
end;

function ML.ui.OkCloseDialog()
	local OnClose = MLDialogFrame_OkOnClose:GetText();
	local itemID = MLDialogFrame_itemID:GetText();
	if( OnClose ~= "" )then
		local exec = _G[OnClose];
		if( exec ~= nil )then exec( itemID ); end;
	end;
	MLDialogFrame:Hide();
end;

function ML.ui.CancelCloseDialog()
	MLDialogFrame:Hide();
end;


--[[ Config frame functions ]]

function ML.ui.SaveProperties()
	mAutoLootVariables.Manual = MLConfigFramePageBar1_chkManual:IsChecked();
	mAutoLootVariables.GroupLootDelay = MLConfigFramePageBar1_Delay:GetValue();
	mAutoLootVariables.ExtraBag = MLConfigFramePageBar1_chkBag:IsChecked();
	mAutoLootVariables.OpenBank = MLConfigFramePageBar1_chkBank:IsChecked();
	SaveVariables( mAutoLootVariables );
end;

function ML.ui.ConfigFrame_OnShow( this )
	MLConfigFrame_Title:SetText( ML.Name .. " " .. ML.Version .. " конфигурация" );
	MLConfigFrame_CloseButton:SetText("Закрыть");
	
	-- Main
	MLConfigFramePageBar1_chkManual_Text:SetText("Показывать мануал режимов пометки мусора/продаж");
	MLConfigFramePageBar1_chkManual:SetChecked( mAutoLootVariables.Manual );
	MLConfigFramePageBar1_chkBag_Text:SetText("Изменять внешний вид инвентаря");
	MLConfigFramePageBar1_chkBag:SetChecked( mAutoLootVariables.ExtraBag );
	MLConfigFramePageBar1_DelayDesc:SetText( "Задержка перед автовыбором (лут группы)" );
	MLConfigFramePageBar1_Delay:SetValueStepMode("INT");
	MLConfigFramePageBar1_Delay:SetMinMaxValues( 1, 10 );
	MLConfigFramePageBar1_DelayLow:SetText("1");
	MLConfigFramePageBar1_DelayHigh:SetText("10")
	MLConfigFramePageBar1_Delay:SetValue( mAutoLootVariables.GroupLootDelay );
	MLConfigFramePageBar1_DelayValue:ClearAllAnchors();
	MLConfigFramePageBar1_DelayValue:SetAnchor( "TOPLEFT", "TOPRIGHT", MLConfigFramePageBar1_Delay, 7, 1 );
	MLConfigFramePageBar1_chkBank_Text:SetText("Открывать окно банка вместе с инвентарем (только при измененном)");
	MLConfigFramePageBar1_chkBank:SetChecked( mAutoLootVariables.OpenBank );
	MLConfigFramePageBar1_SaveButton:SetText("Сохранить");
	MLConfigFramePageBar1_ResetButton:SetText("Сбросить");
	
	-- Drop Masks
	ML.ui.redrawDropMasksList( MLConfigFramePageBar2_ScrollBar );
	MLConfigFramePageBar2_Construct_Header_Title:SetText( "Составление масок" );
	MLConfigFramePageBar2_Construct_label1:SetText("Текст маски:");
	MLConfigFramePageBar2_Construct_label2:SetText("Диапазон ID:");
	MLConfigFramePageBar2_Construct_edtMaskText:SetText("");
	MLConfigFramePageBar2_Construct_edtRangeMin:SetText("100000");
	MLConfigFramePageBar2_Construct_edtRangeMax:SetText("999999");
	MLConfigFramePageBar2_Construct_btnNoSpace:SetText("Слово");
	MLConfigFramePageBar2_Construct_btnSpace:SetText("Пробел");
	MLConfigFramePageBar2_Construct_btnNumeric:SetText("Цифры");
	MLConfigFramePageBar2_Construct_btnRNumeric:SetText("Римские цифры");
	MLConfigFramePageBar2_Construct_SaveButton:SetText("Сохранить");
	MLConfigFramePageBar2_Construct_ResetButton:SetText("Сбросить");
	MLConfigFramePageBar2_Construct_label3:SetText("Предустановленные диапазоны ID:");
	UIDropDownMenu_Initialize( MLConfigFramePageBar2_Construct_Range, ML.ui.IDRange );
	UIDropDownMenu_SetSelectedID( MLConfigFramePageBar2_Construct_Range, 1 );
	UIDropDownMenu_SetWidth( MLConfigFramePageBar2_Construct_Range, 218 );
	
	-- Exceptions
	ML.ui.redrawExceptionList( MLConfigFramePageBar3_ScrollBar );
	MLConfigFramePageBar3_Construct_Header_Title:SetText( "Новое исключение" );
	MLConfigFramePageBar3_Construct_label1:SetText("|cff990000ВНИМАНИЕ!|r Данные исключения дейст-");
	MLConfigFramePageBar3_Construct_label2:SetText("вуют только на выбрасываемые по мас-");
	MLConfigFramePageBar3_Construct_label3:SetText("ке предметы!");
	MLConfigFramePageBar3_Construct_label4:SetText("Название предмета:");
	MLConfigFramePageBar3_Construct_ExceptionText:SetText("");
	MLConfigFramePageBar3_Construct_SaveButton:SetText("Сохранить");
	MLConfigFramePageBar3_Construct_ResetButton:SetText("Сбросить");
end;

function ML.ui.TabButtonLoad( this )
	this:SetText( ML.ConfigFrame.Tabs[ this:GetID() ].Name );
	PanelTemplates_TabResize( this, ML.ConfigFrame.Tabs[ this:GetID() ].Size );
end;

function ML.ui.TabButtonClick( id )
	PanelTemplates_SetTab( MLConfigFrame, id );
	for n = 1, #ML.ConfigFrame.Tabs do
		if( n ~= id )then 
			_G[ 'MLConfigFramePageBar' .. tostring( n ) ]:Hide();
		else 
			_G[ 'MLConfigFramePageBar' .. tostring( n ) ]:Show();
		end;
	end;
end;

function ML.ui.ConfigFrame_OnLoad( this )
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256 , 256 );
	-- PanelTemplates_SetNumTabs( MLConfigFrame, #ML.ConfigFrame.Tabs ); PanelTemplates_SetTab( MLConfigFrame, 1 );
	PanelTemplates_SetNumTabs( this, #ML.ConfigFrame.Tabs );
	PanelTemplates_SetTab( this, 1 );

	ML.ui.TabButtonClick( 1 );
end;

function ML.ui.MLConfigFramePageBar1_DelayOnValueChanged( this )
	GCF_Slider_OnValueChanged( this );
	local units = "секунд";
	if( this:GetValue() == 1 )then units = "секунда"; end;
	if( this:GetValue() > 1 )and( this:GetValue() < 5 )then units = "секунды"; end;
	MLConfigFramePageBar1_DelayValue:SetText( tostring( this:GetValue() ) .. " " .. units );
end;

function ML.ui.DropMasksScroll(this, delta)
	if (delta > 0) then
		this:SetValue(this:GetValue() - 2);
	elseif (delta < 0) then
		this:SetValue(this:GetValue() + 2);
	end;
end;

function ML.ui.DropMasksScrollOnValueChanged(this)
	local min, max = this:GetMinMaxValues()
	MLConfigFramePageBar2_ScrollBarScrollDownButton:Enable()
	MLConfigFramePageBar2_ScrollBarScrollUpButton:Enable()
	if this:GetValue() == min then
		MLConfigFramePageBar2_ScrollBarScrollUpButton:Disable()
	end
	if this:GetValue() == max then
		MLConfigFramePageBar2_ScrollBarScrollDownButton:Disable()
	end
	ML.ui.redrawDropMasksList( MLConfigFramePageBar2_ScrollBar );
end

function ML.ui.redrawDropMasksList( this )
	local max = #mAutoLootVariables.MaskedGarbageList - 15;
	if( max < 0 )then max = 0; end;
	this:SetMinMaxValues( 0, max );
	for n = 1, 16 do
		local i = n + this:GetValue()
		local btn = _G["MLConfigFramePageBar2_DropMasksList_Button"..n]
		local txt = _G["MLConfigFramePageBar2_DropMasksList_Button"..n.."_txt"]
		local range = _G["MLConfigFramePageBar2_DropMasksList_Button"..n.."_range"]
		local _mask = "";
		local _range = "";
		if( #mAutoLootVariables.MaskedGarbageList >= i  )then
			btn:Show();
			_mask = mAutoLootVariables.MaskedGarbageList[ i ]["mask"];
			_range = tostring( mAutoLootVariables.MaskedGarbageList[ i ]["range"]["min"] ) .. "-" .. tostring( mAutoLootVariables.MaskedGarbageList[ i ]["range"]["max"] );
		else
			btn:Hide();
		end;
		txt:SetText( _mask );
		range:SetText( _range );
	end
end;

function ML.ui.ShowDropMaskHint(this)
end;

function ML.ui.ShowButtonHint(this, message)
	GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
	GameTooltip:SetText( "Составление масок", 1, 1, 1 );
	GameTooltip:AddSeparator();
	GameTooltip:AddLine( message );
	GameTooltip:Show();
end;

function ML.ui.SaveDropMask()
	local _NewMask = {
		["range"] = {
			["min"] = MLConfigFramePageBar2_Construct_edtRangeMin:GetText(),
			["max"] = MLConfigFramePageBar2_Construct_edtRangeMax:GetText(),
		},
		["mask"] = MLConfigFramePageBar2_Construct_edtMaskText:GetText(),
	};
	mAutoLootVariables.MaskedGarbageList[ #mAutoLootVariables.MaskedGarbageList + 1 ] = _NewMask;
	ML.ui.ResetDropMaskForm();
	ML.ui.redrawDropMasksList( MLConfigFramePageBar2_ScrollBar );
end;

function ML.ui.ResetDropMaskForm()
	UIDropDownMenu_SetSelectedID( MLConfigFramePageBar2_Construct_Range, 1 );
	MLConfigFramePageBar2_Construct_edtRangeMin:SetText("100000");
	MLConfigFramePageBar2_Construct_edtRangeMax:SetText("999999");
	MLConfigFramePageBar2_Construct_edtMaskText:SetText("");
end;

function ML.ui.IDRange()
	local menuitem = {};
	menuitem.checked = false
	for i = 1, #ML.IDRanges do
		menuitem.text = ML.IDRanges[i]["title"]
		menuitem.func = function()
			MLConfigFramePageBar2_Construct_edtRangeMin:SetText(ML.IDRanges[i]["min"]);
			MLConfigFramePageBar2_Construct_edtRangeMax:SetText(ML.IDRanges[i]["max"]);
			UIDropDownMenu_SetSelectedID(MLConfigFramePageBar2_Construct_Range, i)
		end;
		UIDropDownMenu_AddButton(menuitem, UIDROPDOWNMENU_MENU_LEVEL);
	end
	UIDropDownMenu_SetSelectedID(MLConfigFramePageBar2_Construct_Range, UIDropDownMenu_GetSelectedID(MLConfigFramePageBar2_Construct_Range))
end;



function ML.ui.ExceptionsScroll(this, delta)
	if (delta > 0) then
		this:SetValue(this:GetValue() - 2);
	elseif (delta < 0) then
		this:SetValue(this:GetValue() + 2);
	end;
end;

function ML.ui.ExceptionsScrollOnValueChanged(this)
	local min, max = this:GetMinMaxValues()
	MLConfigFramePageBar2_ScrollBarScrollDownButton:Enable()
	MLConfigFramePageBar2_ScrollBarScrollUpButton:Enable()
	if this:GetValue() == min then
		MLConfigFramePageBar2_ScrollBarScrollUpButton:Disable()
	end
	if this:GetValue() == max then
		MLConfigFramePageBar2_ScrollBarScrollDownButton:Disable()
	end
	ML.ui.redrawExceptionList( MLConfigFramePageBar3_ScrollBar );
end;

function ML.ui.redrawExceptionList( this )
	local max = #mAutoLootVariables.ExceptionsList - 15;
	if( max < 0 )then max = 0; end;
	this:SetMinMaxValues( 0, max );
	for n = 1, 16 do
		local i = n + this:GetValue()
		local btn = _G["MLConfigFramePageBar3_ExceptionList_Button"..n]
		local txt = _G["MLConfigFramePageBar3_ExceptionList_Button"..n.."_txt"]
		local _mask = "";
		if( #mAutoLootVariables.ExceptionsList >= i  )then
			btn:Show();
			_mask = mAutoLootVariables.ExceptionsList[ i ];
		else
			btn:Hide();
		end;
		txt:SetText( _mask );
	end
end;

function ML.ui.SaveException()
	mAutoLootVariables.ExceptionsList[ #mAutoLootVariables.ExceptionsList + 1 ] = MLConfigFramePageBar3_Construct_ExceptionText:GetText();
	ML.ui.ResetExceptionForm();
	ML.ui.redrawExceptionList( MLConfigFramePageBar3_ScrollBar );
end;

function ML.ui.ResetExceptionForm()
	MLConfigFramePageBar3_Construct_ExceptionText:SetText("");
end;

function ML.ui.BagFrameScrollOnValueChanged(this)
	local min, max = this:GetMinMaxValues()
	MLBagFrameScrollFrameScrollBarScrollDownButton:Enable()
	MLBagFrameScrollFrameScrollBarScrollUpButton:Enable()
	if this:GetValue() == min then
		MLBagFrameScrollFrameScrollBarScrollUpButton:Disable()
	end
	if this:GetValue() == max then
		MLBagFrameScrollFrameScrollBarScrollDownButton:Disable()
	end
	ML.ui.redrawBagFrame( MLBagFrameScrollFrameScrollBar );
end;

function ML.ui.BagFrameScroll(this,delta)
	if (delta > 0) then
		this:SetValue(this:GetValue() - 2);
	elseif (delta < 0) then
		this:SetValue(this:GetValue() + 2);
	end;
end;

function ML.ui.redrawBagFrame( this )
	local delta = 0;
	for n = 1, 7 do
		delta = delta + _G[ "MLBagFrameBagButton" .. n ]:GetHeight();
		delta = delta + _G[ "MLBagFrameBagPanel" .. n ]:GetHeight();
		delta = delta + 3
	end;
	delta = delta - 26;
	this:SetMinMaxValues( 0, math.floor( ( delta - MLBagFrameScrollFrame:GetHeight() ) / mAutoLootVariables.ScrollDelta ) );
	MLBagFrameScrollChild:ClearAllAnchors();
	MLBagFrameScrollChild:SetAnchor( "TOPLEFT", "TOPLEFT", MLBagFrameScrollFrame, 5, 5 - ( this:GetValue() * mAutoLootVariables.ScrollDelta ) );
end;

function ML.ui.ShowHideBagItems( this )
	local stRanges = ML.stRanges;
	local id = this:GetID();
	if( mAutoLootVariables.BagFrames[ id ] == nil )then
		mAutoLootVariables.BagFrames[ id ] = {};
		mAutoLootVariables.BagFrames[ id ]["state"] = ( _G[ "MLBagFrameBagPanel" .. id ]:GetHeight() > 100 );
	end;
	
	local min = stRanges[ id ]["min"];
	local max = stRanges[ id ]["max"];
	if( mAutoLootVariables.BagFrames[ id ]["state"] )then

		_G[ "MLBagFrameBagPanel" .. id ]:SetHeight(15);
		for n = min, max do _G[ "BagItemButton" .. n ]:Hide(); end;
		
	else
	
		_G[ "MLBagFrameBagPanel" .. id ]:SetHeight(123);
		for n = min, max do _G[ "BagItemButton" .. n ]:Show(); end;
		
	end;
	mAutoLootVariables.BagFrames[ id ]["state"] = ( _G[ "MLBagFrameBagPanel" .. id ]:GetHeight() > 100 );
	ML.ui.redrawBagFrame( MLBagFrameScrollFrameScrollBar );
end;

function ML.ui.ScrollIt( this, delta )
	UIPanelScrollFrame_OnMouseWheel( MLBagFrameScrollFrameScrollBar, delta );
end;

function ML.ui.GarbageFrameOnShow( this )
	GarbageFrame:ClearAllAnchors();
	GarbageFrame:SetAnchor( "BOTTOMRIGHT", "BOTTOMLEFT", MLBagFrame, -25, -3 );
	GarbageFrame:Show();
end;

function ML.ui.BagStoreUpButton_OnClick( id )
	OpenTimeFlagStoreUpFrame( "BagLet" .. id );
end;

function ML.ui.RefreshBag( id )
	RefreshBag( id );
end;

function ML.ui.UpdateBagPageLetTimes( id )
	local bagButton = _G[ "MLBagFrameBagButton" .. id ];
	local bagTitle  = _G[ "MLBagFrameBagButton" .. id .. "Title" ];
	local isLet, letTime = GetBagPageLetTime( id );
	if ( not isLet or letTime >= 5184000 ) then
		BagStoreUpButton:Hide();
		BagLetTimeText:SetText("");
	else
		if ( IsEnableMerchant() ) then
			BagStoreUpButton:Show();
		end
		
		if ( letTime < 0 ) then
			bagTitle:SetText( "Сумка " .. id .. " (" .. BANK_LET_OVER_TIME .. ")" );
			--BagLetTimeText:SetText(BANK_LET_OVER_TIME);
		else
			local day = math.floor( letTime / 60 / 24 );
			local hour = math.floor( ( letTime - ( day * 60 * 24 ) ) / 60 );
			local minute = letTime - ( day * 60 * 24 ) - ( hour * 60 );
			--BagLetTimeText:SetText(string.format(BANK_LETTIME_MSG , day , hour , minute));
			bagTitle:SetText( "Сумка " .. id .. " (" .. string.format( BANK_LETTIME_MSG, day, hour, minute ) .. ")" );
		end
	end
end;

function ML.ui.MLBagFrameOnUpdate( this, elapsedTime )
	for n = 3, 6 do
		ML.ui.UpdateBagPageLetTimes( n );
	end;
	local cuurent, maxCount = GetBagCount();
	MLBagTitleText:SetText( BagTitleText:GetText() .. ": " );
	MLBagCountText:SetText( cuurent .. "/" .. maxCount );
	if( this:IsVisible() )then
		local X, Y = unpack( {this:GetPos()} );
		mAutoLootVariables.BagFrameX = X;
		mAutoLootVariables.BagFrameY = Y;
	end;
end;

function ML.ui.BagFrameScrollTo( id )
	local stPositions = {
		[1] = 0,
		[2] = 152,
		[3] = 297,
		[4] = 442,
		[5] = 587,
		[6] = 732,
	};
	if( id < 7 )then
		MLBagFrameScrollFrameScrollBar:SetValue( math.floor( stPositions[ id ] / mAutoLootVariables.ScrollDelta ) );
	else
		local min, max = MLBagFrameScrollFrameScrollBar:GetMinMaxValues();
		MLBagFrameScrollFrameScrollBar:SetValue( max );
	end;
end;


function ML.ui.BagFrameOnHide( this )
	MLBagFrameButtons:Hide();
	ML.BagItems = {};
	ML.GoodsItems = {};
	for n = 1, 180 do
		local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( n );
		ML.BagItems[ n ] = {
			["icon"]  = icon,
			["name"]  = name,
			["count"] = itemCount,
		};
	end;
	
	for n = 1, 50 do
		local icon, name, itemCount, locked = GetGoodsItemInfo( n );
		ML.GoodsItems[ n ] = {
			["icon"]  = icon,
			["name"]  = name,
			["count"] = itemCount,
		};
	end;
	if( BankFrame:IsVisible() )then BankFrame:Hide(); end;
	ML.ui.FindByName( "" );
end;

function ML.ui.BagFrameOnShow( this )
	for n = 1, 180 do
		local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( n );
		if( ML.BagItems[ n ] ~= nil )then
			if( ( ML.BagItems[ n ]["icon"] ~= icon )or( ML.BagItems[ n ]["name"] ~= name )or( ML.BagItems[ n ]["count"] ~= itemCount ) )and( itemCount > 0 )then
				if( _G[ "MLBagItemButton" .. n .. "Selection" ] ~= nil )then
					local frame = _G[ "MLBagItemButton" .. n .. "Selection" ];
					frame:ClearAllAnchors();
					frame:SetAnchor( "CENTER","CENTER", _G[ "BagItemButton" .. n ], 0, 0 );
					frame:Show();
				end;
			else
				if( _G[ "MLBagItemButton" .. n .. "Selection" ] ~= nil )then
					_G[ "MLBagItemButton" .. n .. "Selection" ]:Hide();
				end;
			end;
		end;
	end;
	
	for n = 1, 50 do
		local icon, name, itemCount, locked = GetGoodsItemInfo( n );
		if( ML.GoodsItems[ n ] ~= nil )then
			if( ( ML.GoodsItems[ n ]["icon"] ~= icon )or( ML.GoodsItems[ n ]["name"] ~= name )or( ML.GoodsItems[ n ]["count"] ~= itemCount ) )and( itemCount > 0 )then
				if( _G[ "MLGoodsItemButton" .. n .. "Selection" ] ~= nil )then
					local frame = _G[ "MLGoodsItemButton" .. n .. "Selection" ];
					frame:ClearAllAnchors();
					frame:SetAnchor( "CENTER","CENTER", _G[ "GoodsItemButton" .. n ], 0, 0 );
					frame:Show();
				end;
			else
				if( _G[ "MLGoodsItemButton" .. n .. "Selection" ] ~= nil )then
					_G[ "MLGoodsItemButton" .. n .. "Selection" ]:Hide();
				end;
			end;
		end;
	end;

	if( mAutoLootVariables.OpenBank )then
		ML.ui.OpenBankFrame();
	end;
end;

function ML.ui.BagFrame_OnEvent(this, event, arg1, arg2)
--	ML.Message( event );
end;

function ML.ui.OpenBankFrame()
	if( BankFrame:IsVisible() )then
		BankFrame:Hide();
	else
		OpenBank();
	end;
end;

function ML.ui.FindByName( pattern )
	pattern = ML.tools.ChangeCase( pattern );
	local flag = false;
	for n = 1, 180 do
		local inventoryIndex, icon, name, itemCount, locked, quality = GetBagItemInfo ( n );
		name = ML.tools.ChangeCase( name );
		if( name:find( pattern ) ~= nil )and( pattern ~= "" )then
			_G[ "BagItemButton" .. n .. "Quality" ]:Show();
			_G[ "BagItemButton" .. n .. "Quality" ]:SetAlpha( 1 );
			_G[ "BagItemButton" .. n .. "Quality" ]:SetColor( 1, 0, 0 );
			_G[ "BagItemButton" .. n .. "Quality" ]:SetTexture( "interface/buttons/quickslot-qualityborder" );
			_G[ "MLBagItemButton" .. n .. "Selection" ]:ClearAllAnchors();
			_G[ "MLBagItemButton" .. n .. "Selection" ]:SetAnchor( "CENTER","CENTER", _G[ "BagItemButton" .. n ], 0, 0 );
			_G[ "MLBagItemButton" .. n .. "Selection" ]:Show();
			_G[ "MLBagItemButton" .. n .. "Selection_Color" ]:SetColor( 1, 0, 0 );
			if( not flag )then
				ML.ui.BagFrameScrollTo( tonumber( string.sub( _G[ "BagItemButton" .. n ]:GetParent():GetName(), -1 ) ) );
				flag = true;
			end;
		else
			if( quality < 1 )then _G[ "BagItemButton" .. n .. "Quality" ]:Hide(); else _G[ "BagItemButton" .. n .. "Quality" ]:Show(); end;
			_G[ "BagItemButton" .. n .. "Quality" ]:SetColor( GetItemQualityColor( quality ) );
			_G[ "BagItemButton" .. n .. "Quality" ]:SetTexture( "interface/buttons/quickslot-qualityborder01" );
			_G[ "MLBagItemButton" .. n .. "Selection" ]:Hide();
			_G[ "MLBagItemButton" .. n .. "Selection_Color" ]:SetColor( 1, 1, 0.8 );
		end;
	end;
end;

function ML.ui.QueueLabelOnUpdate( this, elapsedTime )
	if( not ItemQueueButton1:IsVisible() )then 
		_G[ this:GetName() .. "Text" ]:SetText( "" );
		return nil;
	end;
	if( this.Count == nil )then this.Count = 0; end;
	local count = 0;
	for n = 1, 20 do
		if( GetItemQueueInfo( n ) ~= nil )then count = count + 1; end;
	end;
	if( count ~= this.Count )then
		_G[ this:GetName() .. "Text" ]:SetText( MLib.PercentFormat( 100 - math.floor( count * 100 / 20 ), count ) );
		this.Count = count;
	end;
end;

--[[ /run dofile("Interface/AddOns/mLoot/code/ui.lua"); ]]