--[[ ML.utils ]]

function ML.utils.looting()
	if( not mAutoLootVariables.Enabled )then return nil; end;
	--[[ 0 for male and 1 for female, 2 for elite mobs and above 2 for boss mobs ]]
	if( UnitSex('target') > 2 )and( not mAutoLootVariables.AutoLootBoss )then return nil; end;
	if( UnitSex('target') == 2 )and( not mAutoLootVariables.AutoLootElit )then return nil; end;
	for n = 1, GetBootyNumItems() do
		--[[ 0 = Common, 1 = Normal, 2 = Good, 3 = Rare, 4 = Epic ]]
		local itemIconFile, itemName, itemCount, itemQuality = GetBootyItemInfo( n );
		if( itemQuality <= mAutoLootVariables.Quality )or( itemQuality == 8 )then ClickBootyItem( n ); end;
	end;
end;

function ML.utils.addGarbage( _, link )
	if( ML.tools.itemID( link ) == nil )then
		ML.Message( "Использование mldrop:" );
		ML.Message( "   /mldrop [ItemLink]" );
		return nil;
	end;
	ML.tools.AddGarbage( link );
end;

function ML.utils.addMaskedGarbage( _, text )
	--[[ MaskedGarbageList ]]
	if( text == "" )then
		ML.Message( "Использование mlmaskdrop:" );
		ML.Message( "   /mlmaskdrop [DropMask]" );
		ML.Message( "   [DropMask] - маска названия предмета, например для всех рун уровня 1 (Удар I,Сила I и т.п.) (.+)%s+I" );
		return nil;
	end;
	mAutoLootVariables.MaskedGarbageList[#mAutoLootVariables.MaskedGarbageList + 1] = text;
end;

function ML.utils.Donate( slot )
	if( not mAutoLootVariables.AutoGuildDonate )then return nil; end;
	local index = GetBagItemInfo( slot );
	PickupBagItem( index );
	GCB_GetContributionItem( index );
	GCB_OnOK();
end;

function ML.utils.GarbageDrop()
	if( not mAutoLootVariables.Enabled )then return nil; end;
	local _, bagCount = GetBagCount()
	local garbageCount = #mAutoLootVariables.GarbageList;
	local maskedGarbageCount = #mAutoLootVariables.MaskedGarbageList;
	for slot = 1, bagCount do
		local itemID = ML.tools.itemID( GetBagItemLink( GetBagItemInfo( slot ) ) );
		--[[ если id предмета находится в мусорке - выбрасываем ]]
		if( mAutoLootVariables.GarbageList[ itemID ] )then
			PickupBagItem( GetBagItemInfo( slot ) );
			DeleteCursorItem();
		end;
		if( mAutoLootVariables.DonateList[ itemID ] )then
			ML.utils.Donate( slot );
		end;
		--[[ ищем в мусорке по маскам ]]
		for n = 1, maskedGarbageCount do
			local _,_,name = GetBagItemInfo( slot );
			if( name:match( "^" .. mAutoLootVariables.MaskedGarbageList[ n ]["mask"] .. "$" ) )then
				if( tonumber( itemID ) >= tonumber( mAutoLootVariables.MaskedGarbageList[ n ]["range"]["min"] ) )and( tonumber( itemID ) <= tonumber( mAutoLootVariables.MaskedGarbageList[ n ]["range"]["max"] ) )then
					local flag = false;
					for i = 1, #mAutoLootVariables.ExceptionsList do
						if( mAutoLootVariables.ExceptionsList[ i ] == name )then flag = true; end;
					end;
					if( not flag )then
						PickupBagItem( GetBagItemInfo( slot ) );
						DeleteCursorItem();
						--ML.Message( name );
					end;
				end;
			end;
		end;
	end
end;

function ML.utils.SetLootMethod()
	if( mAutoLootVariables.RollType == 100 )then
		SetLootMethod( "freeforall" );
	elseif( mAutoLootVariables.RollType == 101 )then
		SetLootMethod( "master", UnitName("player") );
	else
		SetLootMethod( "alternate", mAutoLootVariables.RollType );
	end;
end;

function ML.utils.AutoSell()
	--ClickRepairAllButton(); -- минибонус - авторемонт эквипа
	if( not mAutoLootVariables.AutoSell )then return nil; end;
	local sellCount = #mAutoLootVariables.SellList;
	local _, bagCount = GetBagCount()
	for slot = 1, bagCount do
		local itemID = ML.tools.itemID( GetBagItemLink( GetBagItemInfo( slot ) ) );
		--[[ если id предмета находится в sell листе - продаем ]]
		if( mAutoLootVariables.SellList[ itemID ] )then
			UseBagItem( GetBagItemInfo( slot ) );
		end;
	end;
end;

-- /run dofile("Interface/AddOns/mLoot/code/utils.lua");